# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b16"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/9/cells/1")
sage.server.notebook.interact.SAGE_CELL_ID=1
# See Section 3 of Khandani-Lo "What Happened to the Quants in August 2007?"

price_series = finance.Stock('goog').close()

def strategy(price_series, start, stop, n):
    investment = Integer(1)
    print '%-6s%-8s%-4s%-8s%-8s%8s'%('day','price','sig','strategy ', 'long', '% change')
    start_price = price_series[start]
    for k in range(start, stop-Integer(1)):
         if price_series[k] >= price_series[k-Integer(1)]:
             signal = +Integer(1)
         else:
             signal = -Integer(1)
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         print '%-6s%-8.2f%2s  %-3.2f%8.2f%8.2f'%(k, price_series[k],
                   signal, investment, price_series[k]/start_price, percent_change)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))


# Try changing the 100 below to get a different number of days or range
# of days.  Try changing 20 to average a different number of values.
exec compile(ur'strategy(price_series, len(price_series)-Integer(100), len(price_series), Integer(20))' + '\n', '', 'single')

print "e16"
