# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b87"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/9/cells/0")
sage.server.notebook.interact.SAGE_CELL_ID=0
price_series = finance.Stock('aapl').close()

#price_series = load('http://sage.math.washington.edu/home/simuw/simuw08/data/sobj/DJI.sobj')

def strategy(price_series, start, stop):
    buyhold  = []
    strategy = []
    investment = Integer(1)
    print '%-6s%-10s%-4s%-8s%-10s%8s'%('day','price','sig','strategy ', 'buy&hold', '% change')
    start_price = price_series[start]
    for k in range(start, stop-Integer(1)):
         if price_series[k] >= price_series[k-Integer(1)]:
             signal = -Integer(1)
         else:
             signal = +Integer(1)
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         print '%-6s%-10.2f%2s  %-3.2f%10.2f%10.2f'%(k, price_series[k],
                   signal, investment, price_series[k]/start_price, percent_change)
         buyhold.append(price_series[k]/start_price)
         strategy.append(investment)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))
    show(plot(TimeSeries(buyhold),rgbcolor='red') + plot(TimeSeries(strategy)))


# Try changing the numbers below to get a different number of days or range
# of days.
n = len(price_series)
@interact
def f(start=Integer(200), end=Integer(170)):
    if start < end: print "start must be greater than end"; return
    print "Starting %s days ago and going until %s days ago"%(start, end)
    strategy(price_series, n-start, n-end)

print "e87"
